;*******************************************************************************
; DISCLAIMER
; This software is supplied by Renesas Electronics Corporation and is only
; intended for use with Renesas products. No other uses are authorized. This
; software is owned by Renesas Electronics Corporation and is protected under
; all applicable laws, including copyright laws.
; THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
; THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
; LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
; AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
; TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
; ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
; FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
; ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
; BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
; Renesas reserves the right, without notice, to make changes to this software
; and to discontinue the availability of this software. By using this software,
; you agree to the additional terms and conditions found by accessing the
; following link:
; http://www.renesas.com/disclaimer
;
; Copyright (C) 2016 Renesas Electronics Corporation. All rights reserved.
;******************************************************************************
;*******************************************************************************
; System Name  : RZ/T1 CMSIS-RTOS RTX BSP sample program
; File Name    : user_prog_jmp.s
; Version      : 1.0
; Device       : R7S910017
; Abstract     : Sample program for the user program jump function
; Tool-Chain   : ARM DS-5 Development Studio
; OS           : CMSIS-RTOS RTX
; H/W Platform : RZ/T1 Evaluation Board (RTK7910022C00000BR)
; Description  : User program jump function of RZ/T1
; Limitation   : none
;******************************************************************************
;*******************************************************************************
; History      : DD.MM.YYYY Version  Description
;                   : 02.12.2016     1.0          First Release
;******************************************************************************

    AREA   USER_PROG_JUMP, CODE, READONLY

    EXPORT    UserProgJmp

UserProgJmp    FUNCTION

;===================================================================
; Change Low-vector from High-vector 
; And branch to User Program Top Address
;    r0 : User Program Top Address
;===================================================================

    MRC  p15, 0, r4, c1, c0, 0  ; Set SCTLR.V bit to 0 (low-vector)
    AND  r4, r4, #0xFFFFDFFF
    MCR  p15, 0, r4, c1, c0, 0
    ISB                         ; Ensuring Context-changing


    BX   r0                     ; Branch to User Program entry point

    ENDFUNC


    END
