/*******************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only
* intended for use with Renesas products. No other uses are authorized. This
* software is owned by Renesas Electronics Corporation and is protected under
* all applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
* AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software
* and to discontinue the availability of this software. By using this software,
* you agree to the additional terms and conditions found by accessing the
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2016 Renesas Electronics Corporation. All rights reserved.
*******************************************************************************/
/*******************************************************************************
* System Name  : RZ/T1 CMSIS-RTOS RTX BSP sample program
* File Name    : nor_boot.h
* Version      : 1.0
* Device       : R7S910017
* Abstract     : Definition for nor flash boot settings
* Tool-Chain   : IAR Embedded Workbench for ARM / e2studio / ARM DS-5 Development Studio
* OS           : CMSIS-RTOS RTX
* H/W Platform : RZ/T1 Evaluation Board (RTK7910022C00000BR)
* Description  : Define the system settings of nor flash boot.
* Limitation   : none
*******************************************************************************/
/*******************************************************************************
* History      : DD.MM.YYYY Version  Description
*                   : 02.12.2016     1.0          First Release
*******************************************************************************/

#ifndef NOR_BOOT_H
#define NOR_BOOT_H


/******************************************************************************
Macro definitions
******************************************************************************/
#define NOR_BOOT_OK                 BOOT_OK
#define NOR_BOOT_ERR                BOOT_ERR
#define NOR_BOOT_ERR2               BOOT_ERR2

#define NOR_FINALIZE_DISABLE        0x00000000
#define NOR_FINALIZE_ENABLE         0x22360679

#define NOR_BOOT_SETTING_ADDRESS    0x40000000


/******************************************************************************
Typedef definitions
******************************************************************************/
typedef struct st_boot_norbsc_reg
{
    uint32_t    cs0bcr;
    uint32_t    cs0wcr;
    uint32_t    dummy;
    uint32_t    finalize_flag;
} stBOOT_NORBSC_REG;

typedef struct st_boot_norbsc
{
    stBOOT_CACHE           cache;
    stBOOT_NORBSC_REG      norbsc;
    stBOOT_PROG_PARM       prg_parm;
    stBOOT_DUMMY_PARM      dummy;
    CHECKSUM_TYPE          check_sum;
} stBOOT_NORBSC;


/*******************************************************************************
Exported global variables and functions (to be accessed by other files)
*******************************************************************************/


#endif    /* NOR_BOOT_H */

/* End of File */
