/*******************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only
* intended for use with Renesas products. No other uses are authorized. This
* software is owned by Renesas Electronics Corporation and is protected under
* all applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
* AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software
* and to discontinue the availability of this software. By using this software,
* you agree to the additional terms and conditions found by accessing the
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2016 Renesas Electronics Corporation. All rights reserved.
*******************************************************************************/
/*******************************************************************************
* System Name  : RZ/T1 CMSIS-RTOS RTX BSP sample program
* File Name    : vic.h
* Version      : 1.0
* Device       : R7S910017
* Abstract     : VIC functions Header File
* Tool-Chain   : IAR Embedded Workbench for ARM / e2studio / ARM DS-5 Development Studio
* OS           : CMSIS-RTOS RTX
* H/W Platform : RZ/T1 Evaluation Board (RTK7910022C00000BR)
* Description  : Implementation of VIC functions declared in CMSIS Cortex-R4F Core Peripheral Access Layer Header File
* Limitation   : none
*******************************************************************************/
/*******************************************************************************
* History      : DD.MM.YYYY Version  Description
*                   : 02.12.2016     1.0          First Release
*******************************************************************************/

#ifndef _VIC_HEADER_
#define _VIC_HEADER_

/*****************************************************************************
Typedef definitions
******************************************************************************/

#define VIC_TYPE_LEVEL          (0U)
#define VIC_TYPE_EDGE           (1U)

#define VIC_PRIORITY_0          (0)
#define VIC_PRIORITY_1          (1)
#define VIC_PRIORITY_2          (2)
#define VIC_PRIORITY_3          (3)
#define VIC_PRIORITY_4          (4)
#define VIC_PRIORITY_5          (5)
#define VIC_PRIORITY_6          (6)
#define VIC_PRIORITY_7          (7)
#define VIC_PRIORITY_8          (8)
#define VIC_PRIORITY_9          (9)
#define VIC_PRIORITY_10         (10)
#define VIC_PRIORITY_11         (11)
#define VIC_PRIORITY_12         (12)
#define VIC_PRIORITY_13         (13)
#define VIC_PRIORITY_14         (14)
#define VIC_PRIORITY_15         (15)

/*******************************************************************************
Exported global variables and functions (to be accessed by other files)
*******************************************************************************/
void        VIC_EnableIRQ(IRQn_Type);
void        VIC_DisableIRQ(IRQn_Type);
void        VIC_SetPriority(IRQn_Type, uint32_t);
uint32_t    VIC_GetPriority(IRQn_Type);
void        VIC_Enable(void);
void        VIC_EndInterrupt(void);
void        VIC_ClearPIC(IRQn_Type);
void        VIC_SetDetectType(IRQn_Type, uint32_t);
#endif


/* End of File */
