/*******************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only
* intended for use with Renesas products. No other uses are authorized. This
* software is owned by Renesas Electronics Corporation and is protected under
* all applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
* AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software
* and to discontinue the availability of this software. By using this software,
* you agree to the additional terms and conditions found by accessing the
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2016 Renesas Electronics Corporation. All rights reserved.
*******************************************************************************/
/*******************************************************************************
* System Name  : cmt driver functions for cmt fit module.
* File Name    : r_cmt_userdef.h
* Version      : 1.00
* Device       : RZ/T1
* Abstract     : header file for CMT(W) driver interface
* Tool-Chain   : KPIT Tool Chain Ver.15.01 /
* OS           : RTX
* H/W Platform : RZ/T1
* Description  : Functions for using CMT on RZ/T1 devices.
* Limitation   : none
*******************************************************************************/
/*******************************************************************************
* History      : DD.MM.YYYY Version  Description
*              : 02.29.2016 1.0      First Release
*******************************************************************************/

#ifndef _R_CMT_USERDEF_HEADER_
#define _R_CMT_USERDEF_HEADER_

/*******************************************************************************
Includes   <System Includes> , "Project Includes"
*******************************************************************************/
#include "r_typedefs.h"

/*******************************************************************************
Macro definitions
*******************************************************************************/
#define CMT_MASK_CMSTR0_STR0              (0x0001U)
#define CMT_MASK_CMSTR0_STR1              (0x0002U)
#define CMT_MASK_CMSTR1_STR2              (0x0001U)
#define CMT_MASK_CMSTR1_STR3              (0x0002U)
#define CMT_MASK_CMSTR2_STR4              (0x0001U)
#define CMT_MASK_CMSTR2_STR5              (0x0002U)

/*******************************************************************************
Typedef definitions
*******************************************************************************/

/*******************************************************************************
Exported global variables and functions (to be accessed by other files)
*******************************************************************************/
void userdef_cmt_open(uint32_t const channel, cmt_cfg_t * p_cfg);
void userdef_cmt_start(uint32_t const channel, uint32_t const operate_mode);
void userdef_cmt_stop(uint32_t const channel);
void userdef_cmt_set_time_cnt_param(uint32_t const channel, cmt_time_cnt_t * const p_time_cnt_param);
void userdef_cmt_set_compare_match_param(uint32_t const channel, cmt_compare_match_t * const p_compare_match);

#endif /* _R_CMT_USERDEF_HEADER_ */

/* End of File */

