/*******************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only
* intended for use with Renesas products. No other uses are authorized. This
* software is owned by Renesas Electronics Corporation and is protected under
* all applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
* AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software
* and to discontinue the availability of this software. By using this software,
* you agree to the additional terms and conditions found by accessing the
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2016 Renesas Electronics Corporation. All rights reserved.
*******************************************************************************/
/*******************************************************************************
* System Name  : RZ/T1 CMSIS-RTOS RTX BSP sample program
* File Name    : icu_vic.s
* Version      : 1.0
* Device       : R7S910017
* Abstract     : vic vector address
* Tool-Chain   : e2studio
* OS           : CMSIS-RTOS RTX
* H/W Platform : RZ/T1 Evaluation Board (RTK7910022C00000BR)
* Description  : vic vector address for RZ/T1 (in low vector)
* Limitation   : none
*******************************************************************************/
/*******************************************************************************
* History      : DD.MM.YYYY Version  Description
*                   : 02.12.2016     1.0          First Release
*******************************************************************************/

#define Mode_SVC        0x13
#define HVA0            0xA0010200

/* This program is allocated to section "icu_vic" */ 
	.arm

    .global  vic_isr
    .extern  IRQTable
    .extern  IRQNumber
    .extern  IRQNestLevel                /* Flag indicates whether inside an ISR, and the depth of nesting.  0 = not in ISR. */
    .global  VICVectorAddr
    .extern  VIC_ClearPIC

VICVectorAddr:
    .long     vic_isr_001
    .long     vic_isr_002
    .long     vic_isr_003
    .long     vic_isr_004
    .long     vic_isr_005
    .long     vic_isr_006
    .long     vic_isr_007
    .long     vic_isr_008
    .long     vic_isr_009
    .long     vic_isr_010
    .long     vic_isr_011
    .long     vic_isr_012
    .long     vic_isr_013
    .long     vic_isr_014
    .long     vic_isr_015
    .long     vic_isr_016
    .long     vic_isr_017
    .long     vic_isr_018
    .long     vic_isr_019
    .long     vic_isr_020
    .long     vic_isr_021
    .long     vic_isr_022
    .long     vic_isr_023
    .long     vic_isr_024
    .long     vic_isr_025
    .long     vic_isr_026
    .long     vic_isr_027
    .long     vic_isr_028
    .long     vic_isr_029
    .long     vic_isr_030
    .long     vic_isr_031
    .long     vic_isr_032
    .long     vic_isr_033
    .long     vic_isr_034
    .long     vic_isr_035
    .long     vic_isr_036
    .long     vic_isr_037
    .long     vic_isr_038
    .long     vic_isr_039
    .long     vic_isr_040
    .long     vic_isr_041
    .long     vic_isr_042
    .long     vic_isr_043
    .long     vic_isr_044
    .long     vic_isr_045
    .long     vic_isr_046
    .long     vic_isr_047
    .long     vic_isr_048
    .long     vic_isr_049
    .long     vic_isr_050
    .long     vic_isr_051
    .long     vic_isr_052
    .long     vic_isr_053
    .long     vic_isr_054
    .long     vic_isr_055
    .long     vic_isr_056
    .long     vic_isr_057
    .long     vic_isr_058
    .long     vic_isr_059
    .long     vic_isr_060
    .long     vic_isr_061
    .long     vic_isr_062
    .long     vic_isr_063
    .long     vic_isr_064
    .long     vic_isr_065
    .long     vic_isr_066
    .long     vic_isr_067
    .long     vic_isr_068
    .long     vic_isr_069
    .long     vic_isr_070
    .long     vic_isr_071
    .long     vic_isr_072
    .long     vic_isr_073
    .long     vic_isr_074
    .long     vic_isr_075
    .long     vic_isr_076
    .long     vic_isr_077
    .long     vic_isr_078
    .long     vic_isr_079
    .long     vic_isr_080
    .long     vic_isr_081
    .long     vic_isr_082
    .long     vic_isr_083
    .long     vic_isr_084
    .long     vic_isr_085
    .long     vic_isr_086
    .long     vic_isr_087
    .long     vic_isr_088
    .long     vic_isr_089
    .long     vic_isr_090
    .long     vic_isr_091
    .long     vic_isr_092
    .long     vic_isr_093
    .long     vic_isr_094
    .long     vic_isr_095
    .long     vic_isr_096
    .long     vic_isr_097
    .long     vic_isr_098
    .long     vic_isr_099
    .long     vic_isr_100
    .long     vic_isr_101
    .long     vic_isr_102
    .long     vic_isr_103
    .long     vic_isr_104
    .long     vic_isr_105
    .long     vic_isr_106
    .long     vic_isr_107
    .long     vic_isr_108
    .long     vic_isr_109
    .long     vic_isr_110
    .long     vic_isr_111
    .long     vic_isr_112
    .long     vic_isr_113
    .long     vic_isr_114
    .long     vic_isr_115
    .long     vic_isr_116
    .long     vic_isr_117
    .long     vic_isr_118
    .long     vic_isr_119
    .long     vic_isr_120
    .long     vic_isr_121
    .long     vic_isr_122
    .long     vic_isr_123
    .long     vic_isr_124
    .long     vic_isr_125
    .long     vic_isr_126
    .long     vic_isr_127
    .long     vic_isr_128
    .long     vic_isr_129
    .long     vic_isr_130
    .long     vic_isr_131
    .long     vic_isr_132
    .long     vic_isr_133
    .long     vic_isr_134
    .long     vic_isr_135
    .long     vic_isr_136
    .long     vic_isr_137
    .long     vic_isr_138
    .long     vic_isr_139
    .long     vic_isr_140
    .long     vic_isr_141
    .long     vic_isr_142
    .long     vic_isr_143
    .long     vic_isr_144
    .long     vic_isr_145
    .long     vic_isr_146
    .long     vic_isr_147
    .long     vic_isr_148
    .long     vic_isr_149
    .long     vic_isr_150
    .long     vic_isr_151
    .long     vic_isr_152
    .long     vic_isr_153
    .long     vic_isr_154
    .long     vic_isr_155
    .long     vic_isr_156
    .long     vic_isr_157
    .long     vic_isr_158
    .long     vic_isr_159
    .long     vic_isr_160
    .long     vic_isr_161
    .long     vic_isr_162
    .long     vic_isr_163
    .long     vic_isr_164
    .long     vic_isr_165
    .long     vic_isr_166
    .long     vic_isr_167
    .long     vic_isr_168
    .long     vic_isr_169
    .long     vic_isr_170
    .long     vic_isr_171
    .long     vic_isr_172
    .long     vic_isr_173
    .long     vic_isr_174
    .long     vic_isr_175
    .long     vic_isr_176
    .long     vic_isr_177
    .long     vic_isr_178
    .long     vic_isr_179
    .long     vic_isr_180
    .long     vic_isr_181
    .long     vic_isr_182
    .long     vic_isr_183
    .long     vic_isr_184
    .long     vic_isr_185
    .long     vic_isr_186
    .long     vic_isr_187
    .long     vic_isr_188
    .long     vic_isr_189
    .long     vic_isr_190
    .long     vic_isr_191
    .long     vic_isr_192
    .long     vic_isr_193
    .long     vic_isr_194
    .long     vic_isr_195
    .long     vic_isr_196
    .long     vic_isr_197
    .long     vic_isr_198
    .long     vic_isr_199
    .long     vic_isr_200
    .long     vic_isr_201
    .long     vic_isr_202
    .long     vic_isr_203
    .long     vic_isr_204
    .long     vic_isr_205
    .long     vic_isr_206
    .long     vic_isr_207
    .long     vic_isr_208
    .long     vic_isr_209
    .long     vic_isr_210
    .long     vic_isr_211
    .long     vic_isr_212
    .long     vic_isr_213
    .long     vic_isr_214
    .long     vic_isr_215
    .long     vic_isr_216
    .long     vic_isr_217
    .long     vic_isr_218
    .long     vic_isr_219
    .long     vic_isr_220
    .long     vic_isr_221
    .long     vic_isr_222
    .long     vic_isr_223
    .long     vic_isr_224
    .long     vic_isr_225
    .long     vic_isr_226
    .long     vic_isr_227
    .long     vic_isr_228
    .long     vic_isr_229
    .long     vic_isr_230
    .long     vic_isr_231
    .long     vic_isr_232
    .long     vic_isr_233
    .long     vic_isr_234
    .long     vic_isr_235
    .long     vic_isr_236
    .long     vic_isr_237
    .long     vic_isr_238
    .long     vic_isr_239
    .long     vic_isr_240
    .long     vic_isr_241
    .long     vic_isr_242
    .long     vic_isr_243
    .long     vic_isr_244
    .long     vic_isr_245
    .long     vic_isr_246
    .long     vic_isr_247
    .long     vic_isr_248
    .long     vic_isr_249
    .long     vic_isr_250
    .long     vic_isr_251
    .long     vic_isr_252
    .long     vic_isr_253
    .long     vic_isr_254
    .long     vic_isr_255
    .long     vic_isr_256
    .long     vic_isr_257
    .long     vic_isr_258
    .long     vic_isr_259
    .long     vic_isr_260
    .long     vic_isr_261
    .long     vic_isr_262
    .long     vic_isr_263
    .long     vic_isr_264
    .long     vic_isr_265
    .long     vic_isr_266
    .long     vic_isr_267
    .long     vic_isr_268
    .long     vic_isr_269
    .long     vic_isr_270
    .long     vic_isr_271
    .long     vic_isr_272
    .long     vic_isr_273
    .long     vic_isr_274
    .long     vic_isr_275
    .long     vic_isr_276
    .long     vic_isr_277
    .long     vic_isr_278
    .long     vic_isr_279
    .long     vic_isr_280
    .long     vic_isr_281
    .long     vic_isr_282
    .long     vic_isr_283
    .long     vic_isr_284
    .long     vic_isr_285
    .long     vic_isr_286
    .long     vic_isr_287
    .long     vic_isr_288
    .long     vic_isr_289
    .long     vic_isr_290
    .long     vic_isr_291
    .long     vic_isr_292
    .long     vic_isr_293
    .long     vic_isr_294
    .long     vic_isr_295
    .long     vic_isr_296
    .long     vic_isr_297
    .long     vic_isr_298
    .long     vic_isr_299
    .long     vic_isr_300

vic_isr_001:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =1
    B       vic_isr
vic_isr_002:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =2
    B       vic_isr
vic_isr_003:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =3
    B       vic_isr
vic_isr_004:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =4
    B       vic_isr
vic_isr_005:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =5
    B       vic_isr
vic_isr_006:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =6
    B       vic_isr
vic_isr_007:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =7
    B       vic_isr
vic_isr_008:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =8
    B       vic_isr
vic_isr_009:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =9
    B       vic_isr
vic_isr_010:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =10
    B       vic_isr
vic_isr_011:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =11
    B       vic_isr
vic_isr_012:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =12
    B       vic_isr
vic_isr_013:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =13
    B       vic_isr
vic_isr_014:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =14
    B       vic_isr
vic_isr_015:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =15
    B       vic_isr
vic_isr_016:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =16
    B       vic_isr
vic_isr_017:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =17
    B       vic_isr
vic_isr_018:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =18
    B       vic_isr
vic_isr_019:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =19
    B       vic_isr
vic_isr_020:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =20
    B       vic_isr
vic_isr_021:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =21
    B       vic_isr
vic_isr_022:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =22
    B       vic_isr
vic_isr_023:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =23
    B       vic_isr
vic_isr_024:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =24
    B       vic_isr
vic_isr_025:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =25
    B       vic_isr
vic_isr_026:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =26
    B       vic_isr
vic_isr_027:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =27
    B       vic_isr
vic_isr_028:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =28
    B       vic_isr
vic_isr_029:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =29
    B       vic_isr
vic_isr_030:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =30
    B       vic_isr
vic_isr_031:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =31
    B       vic_isr
vic_isr_032:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =32
    B       vic_isr
vic_isr_033:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =33
    B       vic_isr
vic_isr_034:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =34
    B       vic_isr
vic_isr_035:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =35
    B       vic_isr
vic_isr_036:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =36
    B       vic_isr
vic_isr_037:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =37
    B       vic_isr
vic_isr_038:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =38
    B       vic_isr
vic_isr_039:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =39
    B       vic_isr
vic_isr_040:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =40
    B       vic_isr
vic_isr_041:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =41
    B       vic_isr
vic_isr_042:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =42
    B       vic_isr
vic_isr_043:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =43
    B       vic_isr
vic_isr_044:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =44
    B       vic_isr
vic_isr_045:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =45
    B       vic_isr
vic_isr_046:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =46
    B       vic_isr
vic_isr_047:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =47
    B       vic_isr
vic_isr_048:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =48
    B       vic_isr
vic_isr_049:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =49
    B       vic_isr
vic_isr_050:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =50
    B       vic_isr
vic_isr_051:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =51
    B       vic_isr
vic_isr_052:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =52
    B       vic_isr
vic_isr_053:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =53
    B       vic_isr
vic_isr_054:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =54
    B       vic_isr
vic_isr_055:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =55
    B       vic_isr
vic_isr_056:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =56
    B       vic_isr
vic_isr_057:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =57
    B       vic_isr
vic_isr_058:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =58
    B       vic_isr
vic_isr_059:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =59
    B       vic_isr
vic_isr_060:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =60
    B       vic_isr
vic_isr_061:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =61
    B       vic_isr
vic_isr_062:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =62
    B       vic_isr
vic_isr_063:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =63
    B       vic_isr
vic_isr_064:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =64
    B       vic_isr
vic_isr_065:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =65
    B       vic_isr
vic_isr_066:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =66
    B       vic_isr
vic_isr_067:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =67
    B       vic_isr
vic_isr_068:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =68
    B       vic_isr
vic_isr_069:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =69
    B       vic_isr
vic_isr_070:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =70
    B       vic_isr
vic_isr_071:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =71
    B       vic_isr
vic_isr_072:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =72
    B       vic_isr
vic_isr_073:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =73
    B       vic_isr
vic_isr_074:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =74
    B       vic_isr
vic_isr_075:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =75
    B       vic_isr
vic_isr_076:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =76
    B       vic_isr
vic_isr_077:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =77
    B       vic_isr
vic_isr_078:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =78
    B       vic_isr
vic_isr_079:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =79
    B       vic_isr
vic_isr_080:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =80
    B       vic_isr
vic_isr_081:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =81
    B       vic_isr
vic_isr_082:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =82
    B       vic_isr
vic_isr_083:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =83
    B       vic_isr
vic_isr_084:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =84
    B       vic_isr
vic_isr_085:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =85
    B       vic_isr
vic_isr_086:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =86
    B       vic_isr
vic_isr_087:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =87
    B       vic_isr
vic_isr_088:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =88
    B       vic_isr
vic_isr_089:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =89
    B       vic_isr
vic_isr_090:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =90
    B       vic_isr
vic_isr_091:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =91
    B       vic_isr
vic_isr_092:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =92
    B       vic_isr
vic_isr_093:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =93
    B       vic_isr
vic_isr_094:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =94
    B       vic_isr
vic_isr_095:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =95
    B       vic_isr
vic_isr_096:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =96
    B       vic_isr
vic_isr_097:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =97
    B       vic_isr
vic_isr_098:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =98
    B       vic_isr
vic_isr_099:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =99
    B       vic_isr
vic_isr_100:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =100
    B       vic_isr
vic_isr_101:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =101
    B       vic_isr
vic_isr_102:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =102
    B       vic_isr
vic_isr_103:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =103
    B       vic_isr
vic_isr_104:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =104
    B       vic_isr
vic_isr_105:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =105
    B       vic_isr
vic_isr_106:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =106
    B       vic_isr
vic_isr_107:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =107
    B       vic_isr
vic_isr_108:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =108
    B       vic_isr
vic_isr_109:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =109
    B       vic_isr
vic_isr_110:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =110
    B       vic_isr
vic_isr_111:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =111
    B       vic_isr
vic_isr_112:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =112
    B       vic_isr
vic_isr_113:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =113
    B       vic_isr
vic_isr_114:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =114
    B       vic_isr
vic_isr_115:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =115
    B       vic_isr
vic_isr_116:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =116
    B       vic_isr
vic_isr_117:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =117
    B       vic_isr
vic_isr_118:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =118
    B       vic_isr
vic_isr_119:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =119
    B       vic_isr
vic_isr_120:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =120
    B       vic_isr
vic_isr_121:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =121
    B       vic_isr
vic_isr_122:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =122
    B       vic_isr
vic_isr_123:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =123
    B       vic_isr
vic_isr_124:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =124
    B       vic_isr
vic_isr_125:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =125
    B       vic_isr
vic_isr_126:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =126
    B       vic_isr
vic_isr_127:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =127
    B       vic_isr
vic_isr_128:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =128
    B       vic_isr
vic_isr_129:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =129
    B       vic_isr
vic_isr_130:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =130
    B       vic_isr
vic_isr_131:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =131
    B       vic_isr
vic_isr_132:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =132
    B       vic_isr
vic_isr_133:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =133
    B       vic_isr
vic_isr_134:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =134
    B       vic_isr
vic_isr_135:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =135
    B       vic_isr
vic_isr_136:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =136
    B       vic_isr
vic_isr_137:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =137
    B       vic_isr
vic_isr_138:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =138
    B       vic_isr
vic_isr_139:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =139
    B       vic_isr
vic_isr_140:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =140
    B       vic_isr
vic_isr_141:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =141
    B       vic_isr
vic_isr_142:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =142
    B       vic_isr
vic_isr_143:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =143
    B       vic_isr
vic_isr_144:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =144
    B       vic_isr
vic_isr_145:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =145
    B       vic_isr
vic_isr_146:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =146
    B       vic_isr
vic_isr_147:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =147
    B       vic_isr
vic_isr_148:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =148
    B       vic_isr
vic_isr_149:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =149
    B       vic_isr
vic_isr_150:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =150
    B       vic_isr
vic_isr_151:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =151
    B       vic_isr
vic_isr_152:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =152
    B       vic_isr
vic_isr_153:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =153
    B       vic_isr
vic_isr_154:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =154
    B       vic_isr
vic_isr_155:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =155
    B       vic_isr
vic_isr_156:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =156
    B       vic_isr
vic_isr_157:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =157
    B       vic_isr
vic_isr_158:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =158
    B       vic_isr
vic_isr_159:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =159
    B       vic_isr
vic_isr_160:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =160
    B       vic_isr
vic_isr_161:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =161
    B       vic_isr
vic_isr_162:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =162
    B       vic_isr
vic_isr_163:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =163
    B       vic_isr
vic_isr_164:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =164
    B       vic_isr
vic_isr_165:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =165
    B       vic_isr
vic_isr_166:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =166
    B       vic_isr
vic_isr_167:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =167
    B       vic_isr
vic_isr_168:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =168
    B       vic_isr
vic_isr_169:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =169
    B       vic_isr
vic_isr_170:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =170
    B       vic_isr
vic_isr_171:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =171
    B       vic_isr
vic_isr_172:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =172
    B       vic_isr
vic_isr_173:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =173
    B       vic_isr
vic_isr_174:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =174
    B       vic_isr
vic_isr_175:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =175
    B       vic_isr
vic_isr_176:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =176
    B       vic_isr
vic_isr_177:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =177
    B       vic_isr
vic_isr_178:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =178
    B       vic_isr
vic_isr_179:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =179
    B       vic_isr
vic_isr_180:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =180
    B       vic_isr
vic_isr_181:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =181
    B       vic_isr
vic_isr_182:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =182
    B       vic_isr
vic_isr_183:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =183
    B       vic_isr
vic_isr_184:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =184
    B       vic_isr
vic_isr_185:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =185
    B       vic_isr
vic_isr_186:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =186
    B       vic_isr
vic_isr_187:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =187
    B       vic_isr
vic_isr_188:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =188
    B       vic_isr
vic_isr_189:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =189
    B       vic_isr
vic_isr_190:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =190
    B       vic_isr
vic_isr_191:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =191
    B       vic_isr
vic_isr_192:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =192
    B       vic_isr
vic_isr_193:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =193
    B       vic_isr
vic_isr_194:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =194
    B       vic_isr
vic_isr_195:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =195
    B       vic_isr
vic_isr_196:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =196
    B       vic_isr
vic_isr_197:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =197
    B       vic_isr
vic_isr_198:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =198
    B       vic_isr
vic_isr_199:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =199
    B       vic_isr
vic_isr_200:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =200
    B       vic_isr
vic_isr_201:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =201
    B       vic_isr
vic_isr_202:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =202
    B       vic_isr
vic_isr_203:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =203
    B       vic_isr
vic_isr_204:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =204
    B       vic_isr
vic_isr_205:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =205
    B       vic_isr
vic_isr_206:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =206
    B       vic_isr
vic_isr_207:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =207
    B       vic_isr
vic_isr_208:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =208
    B       vic_isr
vic_isr_209:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =209
    B       vic_isr
vic_isr_210:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =210
    B       vic_isr
vic_isr_211:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =211
    B       vic_isr
vic_isr_212:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =212
    B       vic_isr
vic_isr_213:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =213
    B       vic_isr
vic_isr_214:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =214
    B       vic_isr
vic_isr_215:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =215
    B       vic_isr
vic_isr_216:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =216
    B       vic_isr
vic_isr_217:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =217
    B       vic_isr
vic_isr_218:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =218
    B       vic_isr
vic_isr_219:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =219
    B       vic_isr
vic_isr_220:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =220
    B       vic_isr
vic_isr_221:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =221
    B       vic_isr
vic_isr_222:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =222
    B       vic_isr
vic_isr_223:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =223
    B       vic_isr
vic_isr_224:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =224
    B       vic_isr
vic_isr_225:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =225
    B       vic_isr
vic_isr_226:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =226
    B       vic_isr
vic_isr_227:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =227
    B       vic_isr
vic_isr_228:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =228
    B       vic_isr
vic_isr_229:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =229
    B       vic_isr
vic_isr_230:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =230
    B       vic_isr
vic_isr_231:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =231
    B       vic_isr
vic_isr_232:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =232
    B       vic_isr
vic_isr_233:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =233
    B       vic_isr
vic_isr_234:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =234
    B       vic_isr
vic_isr_235:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =235
    B       vic_isr
vic_isr_236:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =236
    B       vic_isr
vic_isr_237:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =237
    B       vic_isr
vic_isr_238:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =238
    B       vic_isr
vic_isr_239:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =239
    B       vic_isr
vic_isr_240:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =240
    B       vic_isr
vic_isr_241:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =241
    B       vic_isr
vic_isr_242:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =242
    B       vic_isr
vic_isr_243:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =243
    B       vic_isr
vic_isr_244:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =244
    B       vic_isr
vic_isr_245:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =245
    B       vic_isr
vic_isr_246:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =246
    B       vic_isr
vic_isr_247:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =247
    B       vic_isr
vic_isr_248:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =248
    B       vic_isr
vic_isr_249:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =249
    B       vic_isr
vic_isr_250:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =250
    B       vic_isr
vic_isr_251:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =251
    B       vic_isr
vic_isr_252:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =252
    B       vic_isr
vic_isr_253:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =253
    B       vic_isr
vic_isr_254:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =254
    B       vic_isr
vic_isr_255:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =255
    B       vic_isr
vic_isr_256:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =256
    B       vic_isr
vic_isr_257:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =257
    B       vic_isr
vic_isr_258:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =258
    B       vic_isr
vic_isr_259:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =259
    B       vic_isr
vic_isr_260:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =260
    B       vic_isr
vic_isr_261:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =261
    B       vic_isr
vic_isr_262:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =262
    B       vic_isr
vic_isr_263:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =263
    B       vic_isr
vic_isr_264:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =264
    B       vic_isr
vic_isr_265:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =265
    B       vic_isr
vic_isr_266:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =266
    B       vic_isr
vic_isr_267:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =267
    B       vic_isr
vic_isr_268:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =268
    B       vic_isr
vic_isr_269:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =269
    B       vic_isr
vic_isr_270:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =270
    B       vic_isr
vic_isr_271:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =271
    B       vic_isr
vic_isr_272:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =272
    B       vic_isr
vic_isr_273:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =273
    B       vic_isr
vic_isr_274:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =274
    B       vic_isr
vic_isr_275:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =275
    B       vic_isr
vic_isr_276:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =276
    B       vic_isr
vic_isr_277:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =277
    B       vic_isr
vic_isr_278:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =278
    B       vic_isr
vic_isr_279:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =279
    B       vic_isr
vic_isr_280:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =280
    B       vic_isr
vic_isr_281:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =281
    B       vic_isr
vic_isr_282:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =282
    B       vic_isr
vic_isr_283:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =283
    B       vic_isr
vic_isr_284:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =284
    B       vic_isr
vic_isr_285:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =285
    B       vic_isr
vic_isr_286:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =286
    B       vic_isr
vic_isr_287:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =287
    B       vic_isr
vic_isr_288:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =288
    B       vic_isr
vic_isr_289:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =289
    B       vic_isr
vic_isr_290:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =290
    B       vic_isr
vic_isr_291:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =291
    B       vic_isr
vic_isr_292:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =292
    B       vic_isr
vic_isr_293:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =293
    B       vic_isr
vic_isr_294:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =294
    B       vic_isr
vic_isr_295:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =295
    B       vic_isr
vic_isr_296:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =296
    B       vic_isr
vic_isr_297:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =297
    B       vic_isr
vic_isr_298:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =298
    B       vic_isr
vic_isr_299:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =299
    B       vic_isr
vic_isr_300:
    /* save vector number to IRQNumber. */
    PUSH    {R0, R1}
    LDR     R1, =300
    B       vic_isr

vic_isr:
    LDR     R0, =IRQNumber
    STR     R1, [R0]
    POP     {R0, R1}

    SUB     LR, LR, #4
    SRSFD   SP!, #Mode_SVC
    CPS     #Mode_SVC
    PUSH    {R0-R3, R12}
    
    AND     R1, SP, #4
    SUB     SP, SP, R1
    PUSH    {R1, LR}

    LDR     R1, =IRQNestLevel           /* Get address of nesting counter */
    LDR     R2, [R1]
    ADD     R2, R2, #1                  /* Increment nesting counter */
    STR     R2, [R1]

    LDR     R2, =IRQNumber
    LDR     R0, [R2]
    LDR     R2, =0
    LDR     R3, =301
    CMP     R0, R2
    BEQ     ret_irq
    
    CMP     R0, R3
    BCC     act_irq
    
    B       ret_irq
    
/* active irq */
act_irq:
    PUSH    {R0-R3}
    BLX     VIC_ClearPIC
    POP     {R0-R3}
    /* ;call user interrupt routine. */
    LDR     R3, =IRQTable
    LSL     R2, R0, #2
    LDR     R3, [R3, R2]

    CMP     R3, #0                      /* Clean up and return if handler address is 0 */
    BEQ     ret_irq

    PUSH    {R0, R1}
    CPSIE   i
    BLX     R3
    CPSID   i

    /* ;load R0-R3 */
    POP     {R0, R1}

/* ;terminate notice */
ret_irq:
    LDR     R3, =HVA0
    LDR     R1, =0
    STR     R1, [R3]
    DMB

    LDR     R0, =IRQNestLevel           /* Get address of nesting counter */
    LDR     R1, [R0]
    SUB     R1, R1, #1                  /* Decrement nesting counter */
    STR     R1, [R0]

    /* load R0-R13, R12, LR, AND adjust SP */
    POP     {R1, LR}
    ADD     SP, SP, R1
    
    POP     {R0-R3, R12}
    RFEFD   SP!
    .END
; End of File 
